#include "console.h"

int SectionCnt;   								 // ڵ
DWORD dwExportVA, dwExPointerToRawData;			 // 浼ĵַϢ
DWORD dwImportVA, dwImPointerToRawData;

// ַļеλת
DWORD OnConvertVAToRawA(DWORD dwTransVA, DWORD dwSectionVA, DWORD dwPointerToRawData)
{
	// ַƫټڽڵPointerToRawDataɽַתļеλ
	// תõĵַ
	return dwTransVA - dwSectionVA + dwPointerToRawData;
}

void ReadDosHeader()
{
	// DOS Header ļʼ
	fseek(g_pFile, 0, SEEK_SET);
	fread(&g_DosHeader, sizeof(g_DosHeader), 1, g_pFile);
	
	// жDOSͷǷϷ
	if(g_DosHeader.e_magic != 0x5A4D)
	{
		printf("DOSͷϷ\n");
		exit(1);
	}
	
	// ӡ
	printf("****** DOS Header ******\n");
	printf("magic: %.4s\n", (CHAR*)&g_DosHeader.e_magic);
	printf("e_lfanew: 0x%X\n\n",g_DosHeader.e_lfanew);

}

void ReadNTHeader()
{
	// DOS Header е e_lfanew 洢 NT Header ļʼƫֵ
	fseek(g_pFile, g_DosHeader.e_lfanew, SEEK_SET);
	fread(&g_NTHeaders, sizeof(g_NTHeaders), 1, g_pFile);
	
	// жǷΪЧPEļ
	if(g_NTHeaders.Signature != 0x4550)
	{
		printf("ЧPEļ\n");
		exit(1);
	}
	
	// ڵ
	SectionCnt = g_NTHeaders.FileHeader.NumberOfSections;

	// ӡ
	printf("****** NT Header ******\n");
	printf("Signature: %.4s\n", (CHAR*)&g_NTHeaders.Signature);
	printf("NumberOfSections: %d\n", g_NTHeaders.FileHeader.NumberOfSections);
	printf("SizeOfOptionalHeader: 0x%X\n", g_NTHeaders.FileHeader.SizeOfOptionalHeader);
	printf("AddressOfEntryPoint: 0x%X\n", g_NTHeaders.OptionalHeader.AddressOfEntryPoint);
	printf("BaseOfCode: 0x%X\n", g_NTHeaders.OptionalHeader.BaseOfCode);
	printf("BaseOfData: 0x%X\n", g_NTHeaders.OptionalHeader.BaseOfData);
	printf("ImageBase: 0x%X\n", g_NTHeaders.OptionalHeader.ImageBase);
	printf("SectionAlignment: 0x%X\n", g_NTHeaders.OptionalHeader.SectionAlignment);
	printf("FileAlignment: 0x%X\n\n", g_NTHeaders.OptionalHeader.FileAlignment);
}

void ReadSectionTable()
{
	// Section Table  NT Header ֮󡣵ǲӦʹ NT Header ĴС
	// ֱӼλãӦʹ File Header е SizeOfOptionalHeader 㡣
	//  Optional Header 仯¼ʹá
	ULONG FileOffset;
	ULONG SectionTableSize;

	FileOffset = g_DosHeader.e_lfanew + sizeof(g_NTHeaders.Signature)
		+ sizeof(g_NTHeaders.FileHeader) + g_NTHeaders.FileHeader.SizeOfOptionalHeader;
	SectionTableSize = g_NTHeaders.FileHeader.NumberOfSections * sizeof(PE_IMAGE_SECTION_HEADER);

	g_pSectionTable = (PE_IMAGE_SECTION_HEADER*)malloc(SectionTableSize);

    // ļָλãļͷʼsectiontableƫFileOffset
	fseek(g_pFile, FileOffset, SEEK_SET);
	
	// ļжȡһSectionTableSizeСݴŵg_pSectionTableָĻַС
	fread(g_pSectionTable, SectionTableSize, 1, g_pFile);
	
	// ӡ
	printf("****** Section Table ******\n");
	for(int i = 0; i < SectionCnt; i++, g_pSectionTable++)
	{
		// ȡõĵַϢ
		if(strcmp(g_pSectionTable->Name, ".edata") == 0)
		{
			dwExportVA = g_pSectionTable->VirtualAddress;
			dwExPointerToRawData = g_pSectionTable->PointerToRawData;
		}
		// ȡõĵַϢ
		if(strcmp(g_pSectionTable->Name, ".idata") == 0)
		{
			dwImportVA = g_pSectionTable->VirtualAddress;
			dwImPointerToRawData = g_pSectionTable->PointerToRawData;
		}
		
		printf("Number%d\n", i+1);
		printf("Name%.8s\n", g_pSectionTable->Name);
		printf("VirtualSize%08x\n", g_pSectionTable->Misc.VirtualSize);
		printf("VirtualAddress0x%08x\n", g_pSectionTable->VirtualAddress);
		printf("SizeOfRawData0x%08x\n", g_pSectionTable->SizeOfRawData);
		printf("PointerToRawData0x%08x\n", g_pSectionTable->PointerToRawData);
		printf("PointerToRelocations0x%08x\n", g_pSectionTable->PointerToRelocations);
		printf("PointerToLinenumbers0x%08x\n", g_pSectionTable->PointerToLinenumbers);
		printf("NumberOfRelocations0x%04x\n", g_pSectionTable->NumberOfRelocations);
		printf("NumberOfLinenumbers0x%04x\n", g_pSectionTable->NumberOfLinenumbers);
		printf("Characteristics0x%08x\n\n", g_pSectionTable->Characteristics);
	}
	
}

// ȡ
void ReadExportTable()
{
	// ӡ
	printf("****** Export Table ******\n");
	
    // Ŀ¼ĵһԪΪ
	printf("ƫƵַ%04x\n", g_NTHeaders.OptionalHeader.DataDirectory[0].VirtualAddress);
	printf("ĴС%04x\n\n", g_NTHeaders.OptionalHeader.DataDirectory[0].Size);
	
	DWORD dwFileOffset;
		
	// ݷǿ
	if (g_NTHeaders.OptionalHeader.DataDirectory[0].VirtualAddress != 0)
	{
		// 󵼳PEļеƫ
		dwFileOffset = OnConvertVAToRawA(g_NTHeaders.OptionalHeader.DataDirectory[0].VirtualAddress, dwExportVA, dwExPointerToRawData);
		
		// ļеƫ
		printf("ƫƣ%04x\n\n", dwFileOffset);
		
		int nNumberOfFunctions = 0;
    	int nNumberOfNames     = 0;
    	
    	g_ExportDir = (PE_IMAGE_EXPORT_DIRECTORY *)malloc(sizeof(PE_IMAGE_EXPORT_DIRECTORY));
    	
    	fseek(g_pFile, dwFileOffset, SEEK_SET);
    	fread(g_ExportDir, sizeof(PE_IMAGE_EXPORT_DIRECTORY), 1, g_pFile);
		
		printf("IMAGE_EXPORT_DIRECTORYṹ: \n");
    	printf("Characteristics%08x(û;Ϊ0)\n", g_ExportDir->Characteristics);
    	printf("TimeDateStamp%08x(ļʱ)\n", g_ExportDir->TimeDateStamp);
    	printf("MajorVersion%08x(û;Ϊ0)\n", g_ExportDir->MajorVersion);
    	printf("MinorVersion%08x(û;Ϊ0)\n", g_ExportDir->MinorVersion);
    	printf("Name%08x(RVAָһDLLļ)\n\n", g_ExportDir->Name);
    	
    	// ȡDLL
    	char chDllName[64] = {0};   // ռֹ֣
    	// ָDLLļƵVAתΪļƫ
    	DWORD dwTemp = OnConvertVAToRawA(g_ExportDir->Name, dwExportVA, dwExPointerToRawData);
    	// ȡDLLļ
    	fseek(g_pFile, dwTemp, SEEK_SET);
    	fread(chDllName, 64, 1, g_pFile);
    	printf("DLLļΪ%s\n\n", chDllName);
    	
    	printf("Base%08x(ʼ)\n", g_ExportDir->Base);
    	
    	// ģ鵼ĺʼ
   		WORD wBase = (WORD)g_ExportDir->Base;
   		
   		// AddressOfFunctions еԪظֵͬʱҲǵĸ
    	// ֵͨ NumberOfNames ֶͬҲԲͬ
   		printf("NumberOfFunctions%d()\n", g_ExportDir->NumberOfFunctions);
    	nNumberOfFunctions = g_ExportDir->NumberOfFunctions;
    	
    	// AddressOfNames еԪظֵʾƵĺ
    	// ͨǣ͵ͬ
    	printf("NumberOfNames%d(Ƶĺ)\n", g_ExportDir->NumberOfNames);
    	nNumberOfNames = g_ExportDir->NumberOfNames;
    	
    	printf("AddressOfFunctions%08x(RVA, ָһɺַɵ)\n", g_ExportDir->AddressOfFunctions);
    	DWORD dwAddressOfFunctions = OnConvertVAToRawA(g_ExportDir->AddressOfFunctions, dwExportVA, dwExPointerToRawData);
    	
    	// һ RVA ֵָһַָɵ顣
    	// ַǴһģеÿһ"Ƶĵ"
    	printf("AddressOfNames%08x(RVA, ָһַָɵ)\n", g_ExportDir->AddressOfNames);
    	// תΪļƫƵַ
    	DWORD dwNameAddressOfFunctions = OnConvertVAToRawA(g_ExportDir->AddressOfNames, dwExportVA, dwExPointerToRawData);
    	
    	// һ RVA ֵָһ WORD 顣
    	// WORD Ǵһģеÿһ"Ƶĵ"šҪ Base ֶеʼš
    	printf("AddressOfNameOrdinals%08x(RVA, ָһDWORD)\n", g_ExportDir->AddressOfNameOrdinals);	
    	// תΪļƫƵַ
    	DWORD dwAddressOfNameOrdinals = OnConvertVAToRawA(g_ExportDir->AddressOfNameOrdinals, dwExportVA, dwExPointerToRawData);
    	
    	// ̬ڴ洢VirtualAddress
    	DWORD *pdwAddressOfFunctions = (DWORD *)calloc(nNumberOfFunctions, sizeof(DWORD));
    	fseek(g_pFile, dwAddressOfFunctions, SEEK_SET);
    	fread(pdwAddressOfFunctions, sizeof(DWORD), nNumberOfFunctions, g_pFile);
    	
    	// ̬ڴ洢RawAddress
    	DWORD *pRowAddressOfFunctions = (DWORD *)calloc(nNumberOfFunctions, sizeof(DWORD));
      	*pRowAddressOfFunctions = OnConvertVAToRawA(*pdwAddressOfFunctions, dwExportVA, dwExPointerToRawData);
	
    	// ̬ڴ洢Ƶַ
    	DWORD *pdwNameAddressOfFunctions = (DWORD *)calloc(nNumberOfNames, sizeof(DWORD));
    	fseek(g_pFile, dwNameAddressOfFunctions, SEEK_SET);
    	fread(pdwNameAddressOfFunctions, sizeof(DWORD), nNumberOfNames, g_pFile);
      	
      	*pdwNameAddressOfFunctions = OnConvertVAToRawA(*pdwNameAddressOfFunctions, dwExportVA, dwExPointerToRawData);
	
    	// ָ룬洢ָ룬Ϊ̶
    	DWORD **pFunctionsName = (DWORD **)calloc(nNumberOfNames, sizeof(char *));  
      		
      	// ڴźƵ
      	char *pchFunctionName = (char *)malloc(sizeof(char) * 64);
      	*pFunctionsName = (DWORD *)pchFunctionName;

    	// 
    	fseek(g_pFile, *pdwNameAddressOfFunctions, SEEK_SET);
      	fread(*pFunctionsName, 64, 1, g_pFile);
	
    	// 
    	WORD *pwFunctionsOrdinals = (WORD *)calloc(nNumberOfNames, sizeof(WORD)); 
    	fseek(g_pFile, dwAddressOfNameOrdinals, SEEK_SET);

      	fread(pwFunctionsOrdinals, sizeof(WORD), 1, g_pFile);
	
    	// ӡúϢ
      	printf("\nOrdinals: %04x\n", *pwFunctionsOrdinals + wBase);
      	printf(": %s\n", *pFunctionsName);
      	printf("RowAddress: %08x\n", *pRowAddressOfFunctions);
      	printf("VirtulAddress: %08x\n", *pdwAddressOfFunctions);	 		 
	}
	else
	{
		printf("ļ޵\n");
	}
}
